unit Mbencode;

interface

uses
  SysUtils, WinTypes, WinProcs, Controls, Forms,
	Balloon, Classes, StdCtrls, Messages,Shellapi,Commdlg,Utils;

type
  TMBEnhanced = class(TForm)
	Preview: TEdit;
    Label1: TLabel;
	GroupBox4: TGroupBox;
	Button2: TButton;
	Button3: TButton;
	Option1: TRadioButton;
	Option2: TRadioButton;
	Option3: TRadioButton;
	MBMacroString1: TEdit;
	MBMacroString2: TEdit;
	MsgCaption: TEdit;
	MacroLabel1: TLabel;
	MacroLabel2: TLabel;
	Label6: TLabel;
	CheckBox1: TCheckBox;
	Opt32bit: TCheckBox;
	CheckBox3: TCheckBox;
	WriteRR: TButton;
	Edit1: TEdit;
	Showme: TButton;
    GroupBox3: TGroupBox;
    IconType: TComboBox;
	GroupBox1: TGroupBox;
    Messageini: TEdit;
	PickIni: TButton;
    Label4: TLabel;
    Label5: TLabel;
	INI3: TEdit;
	INI2: TEdit;
    INI6: TEdit;
	INI5: TEdit;
	INI1: TEdit;
	INI4: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    MBXType: TComboBox;
    Label2: TLabel;
	Labeel3: TLabel;
	OpenIni: TButton;
	procedure IconTypeChange(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure MBMacroString1Change(Sender: TObject);
	procedure MBMacroString2Change(Sender: TObject);
	procedure MsgCaptionChange(Sender: TObject);
	procedure WriteRRClick(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure Button3Click(Sender: TObject);
	procedure Option2Click(Sender: TObject);
	procedure Option3Click(Sender: TObject);
	procedure Option1Click(Sender: TObject);
	procedure CheckBox1Click(Sender: TObject);
	procedure CheckBox3Click(Sender: TObject);
	procedure MsgCaptionKeyPress(Sender: TObject; var Key: Char);
	procedure ShowmeClick(Sender: TObject);
	procedure MsgCaptionExit(Sender: TObject);
	procedure Btn1CapExit(Sender: TObject);
	procedure Opt32bitClick(Sender: TObject);
	procedure PickIniClick(Sender: TObject);
	procedure OpenIniClick(Sender: TObject);
	procedure INI1Change(Sender: TObject);
	procedure MBXTypeChange(Sender: TObject);
  private
	{ Private declarations }
	procedure Update_THMB;
	procedure WHMessageBoxEnhanced;
  public
	{ Public declarations }
  end;

var
	MBEnhanced: TMBEnhanced;
	THMBType,FunctionName, MsgMacros: String;
	THMBFlag1: Integer;
	INIFile: array [byte] of char;
	IconHost,MCap: array [byte] of Char;
	TestIconIndex: Word;
	B1Capt,B2Capt: array [0..15] of Char;
	Errorshown: Bool;
	Opt322,Opt321: String[5];
const	Section: array [0..10] of Char = 'Defaults';

implementation

{$R *.DFM}

{uses styler1;}

procedure TMBEnhanced.Update_THMB;
var Button: String [50];
begin
{Set MBXType options}
	If MBXType.ItemIndex = 0 Then begin
		Option1.Checked := True;
		Option2.Enabled := False;
		Option3.Enabled := False;
	end else begin
		Option2.Enabled := True;
		Option3.Enabled := True;
	end;
{Set function name}
	If Checkbox1.Checked = True Then FunctionName := 'WHMBE' Else
		FunctionName := 'WHMessageBoxEnhanced';
{Set macro option and related string parts}
	If Option1.Checked = True then begin
		MacroLabel1.Enabled := False;
		MacroLabel2.Enabled :=False;
		MBMacroString1.Enabled := False;
		MBMacroString2.Enabled := False;
		THMBType := FunctionName + '(`';
		MsgMacros := ')';
	End;
	If Option2.Checked = True then begin
		MacroLabel1.Enabled := True;
		MacroLabel2.Enabled := False;
		MBMacroString1.Enabled := True;
		MBMacroString2.Enabled := False;
		THMBType := 'IfThen(' + FunctionName + '(`';
		MsgMacros := '), ' + Opt321 + MBMacroString1.Text + Opt322 + ')';
	end;
	If Option3.Checked = True then begin
		MacroLabel1.Enabled := True;
		MacroLabel2.Enabled :=True;
		MBMacroString1.Enabled := True;
		MBMacroString2.Enabled := True;
		THMBType := 'IfThenElse(' + FunctionName + '(`';
		MsgMacros := '), ' + Opt321 + MBMacroString1.Text + Opt322 + ', '
			+ Opt321 + MBMacroString2.Text + Opt322 +')';
	end;

	Preview.Text := THMBType
		+ INI1.Text + #39 +',`'
		+ INI2.Text + #39 +',`'
		+ INI3.Text + #39 +',`'
		+ INI4.Text + #39 +',`'
		+ INI5.Text + #39 +',`'
		+ INI6.Text + #39 +',`'
		+ MsgCaption.Text + #39 +','
		+ IntToStr((IconType.ItemIndex * 16) + MBXType.ItemIndex) + MsgMacros;
end;


procedure TMBEnhanced.FormCreate(Sender: TObject);
var P1: array [byte] of Char;
begin
{Get INI filename}
	StrPCopy(INIFile,ChangeFileExt(ExpandFileName(Application.ExeName),'.INI'));
{Force font}
	Font.Name := 'MS Sans Serif';
{Set hinting}
	GetPrivateProfileString(Section,'Hints','',P1,SizeOf(P1),INIFile);
	If StrPas(P1) = StrPas('Off') Then begin
		Application.ShowHint := False;
		CheckBox3.Checked := False;
	end else begin
		Application.ShowHint := True;
		CheckBox3.Checked := True;
	End;
{Create icon dropdown list}
	IconType.Items.Add('(no icon)');
	IconType.Items.Add('Stop icon');
	IconType.Items.Add('Question icon');
	IconType.Items.Add('Exclamation mark');
	IconType.Items.Add('Information icon');
	Icontype.ItemIndex := 0;
	MBXType.Items.Add('Simple OK message');
	MBXType.Items.Add('OK and Cancel buttons');
	MBXType.Items.Add('Abort/Retry/Ignore buttons');
	MBXType.Items.Add('Yes, No and Cancel buttons');
	MBXType.Items.Add('Yes and No buttons');
	MBXType.Items.Add('Retry and Cancel buttons');
	MBXType.ItemIndex := 0;
{Set default checks}
	Checkbox1.Checked := False;
	THMBType := FunctionName + '(`';
{Lock out illegal 16 bit syntax}
	Opt321 := '`';
	Opt322 := #39;
	Update_THMB;
end;


procedure TMBEnhanced.IconTypeChange(Sender: TObject);
begin
	Update_THMB
end;



procedure TMBEnhanced.MBMacroString1Change(Sender: TObject);
begin
	If (Errorshown = False) and (Semivalidate(MBMacrostring1.Text) = False)
		Then Errorshown := True;
	Update_THMB;
end;

procedure TMBEnhanced.MBMacroString2Change(Sender: TObject);
begin
	If (Errorshown = False) and (Semivalidate(MBMacrostring2.Text) = False)
		Then Errorshown := True;
	Update_THMB;
end;

procedure TMBEnhanced.MsgCaptionChange(Sender: TObject);
begin
	If (Errorshown = False) and (Stringvalidate(Msgcaption.Text) = False)
		Then Errorshown := True;
	Update_THMB;
end;

procedure TMBEnhanced.WriteRRClick(Sender: TObject);
var s1,s2,syntax: string;
	p1: array[0..999] of Char;
begin
	If FunctionName = 'WHMBE' then S1 := 'RR(' else
		S1 := 'RegisterRoutine(';
	If Opt32bit.Checked then begin
		 s2 := '`si32help.dll' + #39 + ',`';
	end else begin
		s2 := '`si16help.dll' + #39 + ',`';
	end;
	syntax := ',`u=SSSSSSSu';
	Edit1.Text := S1 + S2 + FunctionName + #39 + syntax + #39 + ')';
	Edit1.SelectAll;
	Edit1.CopyToClipboard;
	MessageBox(Self.Handle,'Project macro copied to clipboard. '
		+'Paste into the target .HPJ file''s [CONFIG] section or the '
		+'project macro dialog for your authoring tool. For improved '
		+'reliability, try to insure that all uses of this macro in your project use this '
		+'form of the macro.','RegisterRoutine() macro copied...',64);
end;

procedure TMBEnhanced.Button2Click(Sender: TObject);
begin
	Close;
end;

procedure TMBEnhanced.Button3Click(Sender: TObject);
var i1: integer;
	p1,errmsg: array [0..255] of char;
begin
{Do errorchecking}
{Bad macro entry}
	If (Option2.Checked = True) and (MBMacroString1.Text = '') then begin
		StrPCopy(errmsg,'You have specified an IfThen() macro but no macro '
			+'has been entered as the conditional macro to execute. Author the '
			+'conditional macro or create a simple messagebox before retrying '
			+'the copy operation.');
		MessageBox(Self.Handle,errmsg,'Missing macro',16);
		Exit;
	end;
	If (Option3.Checked = True) and
		((MBMacroString1.Text = '') or (MBMacroString2.Text = '')) then begin
		StrPCopy(errmsg,'You have specified an IfThenElse() macro but one or '
			+'both macros have not been entered. Author the '
			+'conditional macro(s) or create a simple messagebox before retrying '
			+'the copy operation.');
		MessageBox(Self.Handle,errmsg,'Missing macro',16);
		Exit;
	end;
{Empty window caption}
	If MsgCaption.Text = '' Then begin
		StrPCopy(errmsg,'No caption was detected for the messagebox. Captionless '
			+'messageboxes are permissible but not very attractive.'+#10#10
			+'Enter a single space character for the caption to avoid further '
			+'display of this warning.');
		MessageBox(Self.Handle,errmsg,'Missing messagebox caption',48);
	end;
	Preview.SelectAll;
	Preview.CopyToClipboard;
	StrPCopy(P1,'The' + FunctionName + ' macro has been copied to the '
		+'clipboard. Paste into your target document or macro entry '
		+'dialog prior to generating a new macro.');
	MessageBox(Self.Handle, p1,'Macro copied to clipboard',64);
end;

procedure TMBEnhanced.Option2Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnhanced.Option3Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnhanced.Option1Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnhanced.CheckBox1Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnhanced.CheckBox3Click(Sender: TObject);
begin
	If Checkbox3.Checked = True Then begin
		Application.ShowHint := True;
		WritePrivateProfileString(Section,'Hints','On',INIFile);
	end else begin
		Application.ShowHint := False;
		WritePrivateProfileString(Section,'Hints','Off',INIFile);
	end;
end;

procedure TMBEnhanced.MsgCaptionKeyPress(Sender: TObject; var Key: Char);
begin
	Case Key Of #22,#27,#28,#29,#92,#96: Key := Chr(0);
	end;
end;


procedure TMBEnhanced.ShowmeClick(Sender: TObject);
var	P2: array [0..50] of Char;
	P1: array [byte] of char;
begin
	WHMessageBoxEnhanced;
end;

procedure TMBEnhanced.MsgCaptionExit(Sender: TObject);
begin
	ErrorShown := False;
end;

procedure TMBEnhanced.Btn1CapExit(Sender: TObject);
begin
	ErrorShown := False;
end;

procedure TMBEnhanced.Opt32bitClick(Sender: TObject);
begin
	If Opt32bit.Checked = True then begin
		Opt321 := '';
		Opt322 := '';
	end else begin
		Opt321 := '`';
		Opt322 := '''';
	end;
	Update_THMB;
end;

procedure TMBEnhanced.PickIniClick(Sender: TObject);
var	filerec: TOpenfilename;
	P1,P2: array [byte] of Char;
begin
	StrPCopy(P1,'');
	StrPCopy(P2,'INI files *.INI' + #0 + '*.INI' + #0);
	filerec.lStructSize := sizeof(TOpenFileName); {length of structure...must be SizeOf(TOpenFileName)}
	filerec.hwndOwner := Self.Handle;  {handle of owner window...mandatory}
	filerec.lpstrFilter := P2;  		{address of filter list...see how P2 was generated; two nulls are needed at end}
	filerec.lpstrCustomFilter := nil;    {custom filter address (e.g. P3)}
	filerec.nFilterIndex := 1;              {not needed here but nice to have in the template}
	filerec.lpstrFile := P1;         {pchar buffer for source filename}
	filerec.nMaxFile := 256; {size of buffer...256 is relatively safe}
	filerec.lpstrFileTitle := nil;          {buffer for saved fileNAME only in case needed by application}
	filerec.lpstrInitialDir := nil;         {initial directory displayed in save dialog}
	filerec.lpstrTitle := 'Select .INI file for this macro'; {title for dialog box...optional}
	filerec.Flags := OFN_HIDEREADONLY + OFN_FILEMUSTEXIST + OFN_NOCHANGEDIR; {optionals}
	filerec.lpstrDefExt := nil;            	{default extension}
	if (GetOpenFileName(filerec) = False) Then begin
		MessageBox(Self.Handle,'No file selected','No .INI file specified',16);
		Exit;
	end else begin
		MessageIni.Text := StrPas(P1);
	end;
end;

procedure TMBEnhanced.OpenIniClick(Sender: TObject);
var	filerec: TOpenfilename;
	P1,P2: array [byte] of Char;
	i1: integer;
begin
	StrPCopy(P1,'');
	StrPCopy(P2,'INI files *.INI' + #0 + '*.INI' + #0);
	filerec.lStructSize := sizeof(TOpenFileName); {length of structure...must be SizeOf(TOpenFileName)}
	filerec.hwndOwner := Self.Handle;  {handle of owner window...mandatory}
	filerec.lpstrFilter := P2;  		{address of filter list...see how P2 was generated; two nulls are needed at end}
	filerec.lpstrCustomFilter := nil;    {custom filter address (e.g. P3)}
	filerec.nFilterIndex := 1;              {not needed here but nice to have in the template}
	filerec.lpstrFile := P1;         {pchar buffer for source filename}
	filerec.nMaxFile := 256; {size of buffer...256 is relatively safe}
	filerec.lpstrFileTitle := nil;          {buffer for saved fileNAME only in case needed by application}
	filerec.lpstrInitialDir := nil;         {initial directory displayed in save dialog}
	filerec.lpstrTitle := 'Select .INI file to browse or edit'; {title for dialog box...optional}
	filerec.Flags := OFN_HIDEREADONLY + OFN_FILEMUSTEXIST + OFN_NOCHANGEDIR; {optionals}
	filerec.lpstrDefExt := nil;            	{default extension}
	if (GetOpenFileName(filerec) = False) Then begin
		MessageBox(Self.Handle,'No file selected','No .INI file specified',16);
		Exit;
	end else begin
		StrPCopy(P2,'notepad.exe '+ StrPas(P1));
		i1 := WinExec(P2,SW_SHOWNORMAL);
		if i1 < 32 then begin
			StrPCopy(P2,'Unable to open ' + StrPas(P1) + ' into Notepad. '
				+'Either reselect the file or correct your Notepad installation '
				+'to eliminate this error.');
			MessageBox(Self.Handle,P2,'Can''t open .INI file',48);
		end;
	end;{getopenfilename}
end;


procedure TMBEnhanced.WHMessageBoxEnhanced;
var Pc1: array [0..1500] of Char;
	IP1,temP1,P1,P2,P3,P4,P5,P6,Cap: array [byte] of Char;
	i1: integer;
	Helpini: array [byte] of Char;
const MsgKey: array [0..10] of Char = 'Messages';

	function FatValidate(MessageString:String):String;
	var Tildeval: Byte;
	begin
		While Pos('~~',Messagestring) <> 0 do begin
			Tildeval := Pos('~~',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(Chr(10),messagestring,TildeVal);
		end;
		While Pos('>>',Messagestring) <> 0 do begin
			Tildeval := Pos('>>',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(' ',messagestring,TildeVal);
		end;
		Result := Messagestring;
	end;

begin
	StrPCopy(HelpIni,MessageIni.Text);
	If INI1.Text <> StrPas('') then begin
		StrPCopy(IP1,INI1.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P1,FatValidate(StrPas(temP1)));
		lstrcpy(@Pc1,P1);
	end else lstrcpy(@Pc1,'');
	If INI2.Text <> StrPas('') then begin
		StrPCopy(IP1,INI2.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P2,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P2);
	end;
	If INI3.Text <> StrPas('') then begin
		StrPCopy(IP1,INI3.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P3,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P3);
	end;
	If INI4.Text <> StrPas('') then begin
		StrPCopy(IP1,INI4.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P4,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P4);
	end;
	If INI5.Text <> StrPas('') then begin
		StrPCopy(IP1,INI5.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P5,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P5);
	end;
	If INI6.Text <> StrPas('') then begin
		StrPCopy(IP1,INI6.Text);
		GetPrivateProfileString(MsgKey,IP1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P6,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P6);
	end;
{Null string?}
	StrPCopy(P1,Pc1[0] + Pc1[1] + Pc1[2]);
	If Length(StrPas(P1)) < 2 then begin
		StrPCopy(P1,'No message entries found...this software may require '
			+'reinstallation to repair a damaged .INI file.'
			+#10#10
			+'(This is the message which displays if none of your specified '
			+'INI entries are found...and none were found for this test.');
		lstrcpy(@Pc1,P1);
	end;
	StrPCopy(Cap,MsgCaption.Text);
{Generate a messagebox}
	MessageBox(Self.Handle,Pc1,Cap,
		(IconType.ItemIndex * 16) + MBXType.ItemIndex);
end;

procedure TMBEnhanced.INI1Change(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnhanced.MBXTypeChange(Sender: TObject);
begin
	Update_THMB;
end;

end.
