unit Mbesamp;

interface

uses
  SysUtils, WinTypes, WinProcs, Controls, Forms,
	Balloon, Classes, StdCtrls, StrRes,Messages,Shellapi,Commdlg;

type
  TMBEnh = class(TForm)
    Label1: TLabel;
	GroupBox4: TGroupBox;
	Button2: TButton;
	Button3: TButton;
	Option1: TRadioButton;
	Option2: TRadioButton;
	Option3: TRadioButton;
	MBMacroString1: TEdit;
	MBMacroString2: TEdit;
	MsgCaption: TEdit;
	MsgContent: TEdit;
	MacroLabel1: TLabel;
	MacroLabel2: TLabel;
	Label6: TLabel;
	Label7: TLabel;
	StrRes1: TStrRes;
	CheckBox1: TCheckBox;
	Opt32bit: TCheckBox;
	CheckBox3: TCheckBox;
	WriteRR: TButton;
	Edit1: TEdit;
    GroupBox2: TGroupBox;
	Btn1Cap: TEdit;
	Btn2Cap: TEdit;
    B1Cap: TLabel;
	B2Cap: TLabel;
	GroupBox3: TGroupBox;
	IconType: TComboBox;
    Preview: TEdit;
    Showme: TButton;
	procedure IconTypeChange(Sender: TObject);
	procedure ShowmeClick(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure MBMacroString1Change(Sender: TObject);
	procedure MBMacroString2Change(Sender: TObject);
	procedure MsgCaptionChange(Sender: TObject);
	procedure MsgContentChange(Sender: TObject);
	procedure WriteRRClick(Sender: TObject);
	procedure Button2Click(Sender: TObject);
	procedure Button4Click(Sender: TObject);
	procedure Button3Click(Sender: TObject);
	procedure Option2Click(Sender: TObject);
	procedure Option3Click(Sender: TObject);
	procedure Option1Click(Sender: TObject);
	procedure CheckBox1Click(Sender: TObject);
	procedure CheckBox3Click(Sender: TObject);
	procedure Btn1CapChange(Sender: TObject);
	procedure Btn2CapChange(Sender: TObject);
	procedure Opt32bitClick(Sender: TObject);
	procedure MsgCaptionKeyPress(Sender: TObject; var Key: Char);
	procedure MsgContentKeyPress(Sender: TObject; var Key: Char);
	procedure Btn1CapKeyPress(Sender: TObject; var Key: Char);
	procedure Btn2CapKeyPress(Sender: TObject; var Key: Char);
  private
	{ Private declarations }
	procedure Update_THMB;
	procedure pmChangeMessageBox ( var Msg: TMessage );	message WM_USER + 1024;
  public
	{ Public declarations }
  end;

var
	MBEnh: TMBEnh;
	THMBType,FunctionName, MsgMacros: String;
	THMBFlag1: Integer;
	INIFile: array [byte] of char;
	IconHost,MCap: array [byte] of Char;
	TestIconIndex: Word;
	B1Capt,B2Capt: array [0..15] of Char;
const	Section: array [0..10] of Char = 'Defaults';
		Opt321 : String [5] = '`';
		Opt322 : String [5] = #39;

implementation

{$R *.DFM}

uses sampmenu;

procedure TMBEnh.Update_THMB;
var Button: String [50];
	Button2Opt: Byte;
begin
{Set function name}
	If Checkbox1.Checked = True Then FunctionName := 'WHMBE' Else
		FunctionName := 'WHMessageBoxEnhanced';
{Set macro option and related string parts}
	If Option1.Checked = True then begin
		MacroLabel1.Enabled := False;
		MacroLabel2.Enabled :=False;
		MBMacroString1.Enabled := False;
		MBMacroString2.Enabled := False;
		B2Cap.Enabled := False;
		Btn2Cap.Enabled := False;
		Button2Opt := 0;
		THMBType := FunctionName + '(`';
		MsgMacros := '';
	End;
	If Option2.Checked = True then begin
		MacroLabel1.Enabled := True;
		MacroLabel2.Enabled := False;
		MBMacroString1.Enabled := True;
		MBMacroString2.Enabled := False;
		B2Cap.Enabled := True;
		Btn2Cap.Enabled := True;
		Button2Opt := 1;
		THMBType := 'IfThen(' + FunctionName + '(`';
		MsgMacros := ' , ' + Opt321 + MBMacroString1.Text + Opt322 + ')';
	end;
	If Option3.Checked = True then begin
		MacroLabel1.Enabled := True;
		MacroLabel2.Enabled :=True;
		MBMacroString1.Enabled := True;
		MBMacroString2.Enabled := True;
		B2Cap.Enabled := True;
		Btn2Cap.Enabled := True;
		Button2Opt := 1;
		THMBType := 'IfThenElse(' + FunctionName + '(`';
		MsgMacros := ' , ' + Opt321 + MBMacroString1.Text + Opt322 + ', ' + Opt321 + MBMacroString2.Text + Opt322 +')';
	end;

{Filter out illegal 16 bit stuff}
	If Opt32bit.Checked = True then
		 Button := ',`' +  Btn2Cap.Text + #39
		 else Button := '';

	Preview.Text := THMBType
		+ MsgContent.Text + #39 +',`'
		+ MsgCaption.Text + #39 +','
		+ '`' + Btn1Cap.Text + #39 + Button + ','
		+ IntToStr((IconType.ItemIndex * 16) + Button2opt) + ')' + MsgMacros;
end;


procedure TMBEnh.FormCreate(Sender: TObject);
var Retstring: array [byte] of Char;
begin
{Get INI filename}
	StrPCopy(INIFile, ChangeFileExt(Application.ExeName,'.INI'));
{Force font}
	Font.Name := 'MS Sans Serif';
{Set hinting}
	GetPrivateProfileString(Section,'Hints','',Retstring,SizeOf(RetString),INIFile);
	If StrPas(RetString) = StrPas('Off') Then begin
		Application.ShowHint := False;
		CheckBox3.Checked := False;
	end else begin
		Application.ShowHint := True;
		CheckBox3.Checked := True;
	End;
{Create icon dropdown list}
	IconType.Items.Add('(no icon)');
	IconType.Items.Add('Stop icon (standard)');
	IconType.Items.Add('Question icon (standard)');
	IconType.Items.Add('Exclamation mark (standard)');
	IconType.Items.Add('Information icon (standard)');
	IconType.Items.Add('Embedded icon in Sorcerer DLL');

{Set default checks}
	Checkbox1.Checked := False;
	IconType.ItemIndex := 0;
	THMBType := FunctionName + '(`';
{Lock out illegal 16 bit syntax}
	Option1.Checked := True;
	Option2.enabled := False;
	Option3.Enabled := False;
	Update_THMB;

end;

procedure TMBEnh.IconTypeChange(Sender: TObject);
begin
	THMBFlag1 := IconType.ItemIndex * 16;
	Update_THMB
end;


procedure TMBEnh.pmChangeMessageBox(var Msg: TMessage);
var MsgboxHwnd: HWND;
{	Fonthandle:HFont;
	DlgFont:TLOGFONT;
	NewFont: HFont;}
	NewIcon : THandle;
begin
{Now, when we fetch the messagebox windowhandle, we need to know its
 caption when using FindWindow. There's probably another way; I don't know it.
 The original author used FindWindow(MAKEINTRESOURCE(WC_DIALOG), 'caption')
 to insure that only dialog windows were polled by FindWindow, but when I
 tried FindWindow(nil,'My Message Caption') it worked just as well.}
	MsgboxHwnd := FindWindow(nil,MCap);
	if (MsgboxHwnd <> 0) then begin
		If (Option1.Checked = False) {32 bit 2-button} then begin
{First let's mess with the button caption text.}
			SetDlgItemText(MsgboxHwnd,1,B1Capt);
			SetDlgItemText(MsgboxHwnd,2,B2Capt);
		end else begin
{Note that the ID of the OK button in a 1-button msgbox
 is actually ID_CANCEL!!}
			SetDlgItemText(MsgboxHwnd,2,B1Capt);
		end;
	end;
{Finally let's apply the application's icon to the messagebox.
 Delphi uses MAINICON as the default. You can specify other icons in your app's
 resources as well. The hard part of this was finding the messagebox item ID for
 the icon. I hacked a little test program together and discovered by trial-and-
 error that its ID is 10.  (Sometimes you get lucky that way...it could have been
 1024, and I was incrementing by 1's when inputting sequential item IDs.)}
	If Testiconindex <> 17 then begin
		NewIcon := ExtractIcon(hinstance,IconHost,TestIconIndex);
		If Newicon <> 0 Then SendDlgItemMessage(Msgboxhwnd,10,STM_SETICON,NewIcon,0);
	end;

{We could also modify a button *font* like so:}
(*
		Fonthandle := SendMessage(MsgboxHwnd,WM_GETFONT,0,0);
		GetObject(Fonthandle,sizeof(TLOGFONT), @Dlgfont);
		strpcopy(Dlgfont.lfFaceName,'Times');
		Dlgfont.lfClipPrecision := CLIP_LH_ANGLES or CLIP_TT_ALWAYS;
		Dlgfont.Lfweight := FW_BOLD;
		DlgFont.lfheight:= 25;
		Dlgfont.lfwidth:= 7;}
		NewFont := CreateFontIndirect(DlgFont);
		If NewFont <> 0 then SendDlgItemMessage(Msgboxhwnd,ID_OK,WM_SETFONT,NewFont,0);
*)

end;



procedure TMBEnh.ShowmeClick(Sender: TObject);
var	P2: array [0..50] of Char;
	P1: array [byte] of char;
	filerec: TOpenfilename;
begin
{Set up the variables to pass to the messagebox and changer routine}
	If Icontype.ItemIndex = 5 then TestIconIndex := 0
		else Testiconindex := 17 {placeholder};
	If MsgCaption.Text = '' then StrPCopy(MCap,'    ') else StrPCopy(MCap,MsgCaption.Text);
	StrPCopy(P1,MsgContent.Text);
	StrPCopy(B1Capt,Btn1Cap.Text);
	StrPCopy(B2Capt,Btn2Cap.Text);
{Now we need to pick the Sampler DLL containing the desired icon}
	StrPCopy(Iconhost,'');
	If Opt32Bit.Checked = True then
		StrPCopy(P2,'32 bit sampler DLL' + #0 + 'si32help.dll'+#0+#0)
	else StrPCopy(P2,'16 bit sampler DLL' + #0 + 'si16help.dll'+#0+#0);
	If TestIconINdex = 0 then begin
		filerec.lStructSize := sizeof(TOpenFileName); {length of structure...must be SizeOf(TOpenFileName)}
		filerec.hwndOwner := Self.Handle;  {handle of owner window...mandatory}
		filerec.lpstrFilter := P2;  		{address of filter list...see how P2 was generated; two nulls are needed at end}
		filerec.lpstrCustomFilter := nil;    {custom filter address (e.g. P3)}
		filerec.nFilterIndex := 1;              {not needed here but nice to have in the template}
		filerec.lpstrFile := Iconhost;         {pchar buffer for source filename}
		filerec.nMaxFile := 256; {size of buffer...256 is relatively safe}
		filerec.lpstrFileTitle := nil;          {buffer for saved fileNAME only in case needed by application}
		filerec.lpstrInitialDir := nil;         {initial directory displayed in save dialog}
		filerec.lpstrTitle := 'Select the sampler DLL containing your custom icon'; {title for dialog box...optional}
		filerec.Flags := OFN_HIDEREADONLY + OFN_FILEMUSTEXIST; {optionals}
		filerec.lpstrDefExt := nil;            	{default extension}
		if (GetOpenFileName(filerec) = False) Then begin
			MessageBox(Self.Handle,'No file selected','No custom icon specified',16);
			Exit;
		end;
	end;
{This message is sent JUST BEFORE we open the messagebox}
	PostMessage(Self.Handle, WM_USER + 1024, 0, 0);
	If Option1.Checked = True then begin
{Here we're using two standard mbx types so changing the components
 will not require excessive variable processing.}
		Messagebox(Self.Handle,P1,MCap,MB_OK + MB_ICONQUESTION);
	end else begin
		MessageBox(Self.Handle,P1,MCap, MB_OKCancel + MB_ICONQUESTION);
	end;
end;


procedure TMBEnh.MBMacroString1Change(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.MBMacroString2Change(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.MsgCaptionChange(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.MsgContentChange(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.WriteRRClick(Sender: TObject);
var s1,s2,syntax: string;
	p1: array[0..999] of Char;
begin
	If FunctionName = 'WHMBE' then
		S1 := 'RR(' else
		S1 := 'RegisterRoutine(';
	If Opt32bit.Checked = True Then begin
		s2 := '`si32help.dll' + #39 + ',`';
		syntax := ',`u=SSSSi';
	end else begin
		s2 := '`si16help.dll' + #39 + ',`';
		syntax := ',`SSSi';
	end;
	Edit1.Text := S1 + S2 + FunctionName + #39 + syntax + #39 + ')';
	Edit1.SelectAll;
	Edit1.CopyToClipboard;
	StrPCopy(p1,StrRes1[3] + StrRes1[4]);
	MessageBox(Self.Handle,p1,'RegisterRoutine() macro copied...',64);
end;

procedure TMBEnh.Button2Click(Sender: TObject);
begin
	Close;
end;

procedure TMBEnh.Button4Click(Sender: TObject);
begin
{
		WriteRR;
}
end;

procedure TMBEnh.Button3Click(Sender: TObject);
var i1: integer;
	p1,errmsg: array [0..255] of char;
begin
{Do errorchecking}
{Bad macro entry}
	If (Option2.Checked = True) and (MBMacroString1.Text = '') then begin
		StrPCopy(errmsg,'You have specified an IfThen() macro but no macro '
			+'has been entered as the conditional macro to execute. Author the '
			+'conditional macro or create a simple messagebox before retrying '
			+'the copy operation.');
		MessageBox(Self.Handle,errmsg,'Missing macro',16);
		Exit;
	end;
	If (Option3.Checked = True) and
		((MBMacroString1.Text = '') or (MBMacroString2.Text = '')) then begin
		StrPCopy(errmsg,'You have specified an IfThenElse() macro but one or '
			+'both macros have not been entered. Author the '
			+'conditional macro(s) or create a simple messagebox before retrying '
			+'the copy operation.');
		MessageBox(Self.Handle,errmsg,'Missing macro',16);
		Exit;
	end;
{Bad button entry}
	If (Btn1Cap.Text = '') or
		((Option1.Checked = False) and (Btn2Cap.Text = ''))
		Then begin
		StrPCopy(errmsg,'Manually edited button caption(s) are mandatory. You have failed to '
			+'enter one or both of your button captions. This will result in empty '
			+'buttons in the messagebox. Add your custom caption(s) and retry the '
			+'copy operation.');
		MessageBox(Self.Handle,errmsg,'Missing button caption',16);
		exit;
	end;
{Empty message}
	If MsgContent.Text = '' Then begin
		StrPCopy(errmsg,'No message text has been entered for this messagebox. '
			+'This messagebox will serve no purpose in your project...copy aborted.'
			+#10#10+ 'If you really do want a "messageless" messagebox, enter a single '
			+'space character to fool the abort mechanism.');
		Messagebox(Self.Handle,errmsg,'No message text defined',16);
		exit;
	end;
{Empty window caption}
	If MsgCaption.Text = '' Then begin
		StrPCopy(errmsg,'No caption was detected for the messagebox. Captionless '
			+'messageboxes are permissible but not very attractive.'+#10#10
			+'Enter a single space character for the caption to avoid further '
			+'display of this warning.');
		MessageBox(Self.Handle,errmsg,'Missing messagebox caption',48);
	end;




	Preview.SelectAll;
	Preview.CopyToClipboard;
	StrPCopy(p1,'The' + FunctionName + StrRes1[2]);
	MessageBox(Self.Handle, p1,'Macro copied to clipboard',64);
end;

procedure TMBEnh.Option2Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.Option3Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.Option1Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.CheckBox1Click(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.CheckBox3Click(Sender: TObject);
begin
	If Checkbox3.Checked = True Then begin
		Application.ShowHint := True;
		WritePrivateProfileString(Section,'Hints','On',INIFile);
	end else begin
		Application.ShowHint := False;
		WritePrivateProfileString(Section,'Hints','Off',INIFile);
	end;
end;

procedure TMBEnh.Btn1CapChange(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.Btn2CapChange(Sender: TObject);
begin
	Update_THMB;
end;

procedure TMBEnh.Opt32bitClick(Sender: TObject);
var P1: array [0..255] of Char;
begin
	If Opt32bit.Checked = False Then begin
		Option1.Checked := True;
		Option2.enabled := False;
		Option3.Enabled := False;
		Opt321 := '`';
		Opt322 := #39;
		StrPCopy(P1,'16 bit DLL selected.  Insure that your project includes the '
			+'16 bit version of the DLL and that the 16 bit RegisterRoutine() macro '
			+'is added to your project''s HPJ or project setup dialog.');
		MessageBox(Self.Handle,P1,'DLL syntax change',mb_IconExclamation);
	end;
	If Opt32bit.Checked = True Then begin
		Option2.enabled := True;
		Option3.Enabled := True;
		Opt321 := '';
		Opt322 := '';
		StrPCopy(P1,'32 bit DLL selected.  Insure that your project includes the '
			+'32 bit version of the DLL and that the 16 bit RegisterRoutine() macro '
			+'is added to your project''s HPJ or project setup dialog.');
		MessageBox(Self.Handle,P1,'DLL syntax change',mb_IconExclamation);
	end;
	Update_THMB;
end;

procedure TMBEnh.MsgCaptionKeyPress(Sender: TObject; var Key: Char);
begin
	Case Key Of #22,#27,#28,#29,#92,#96: Key := Chr(0);
	end;
end;

procedure TMBEnh.MsgContentKeyPress(Sender: TObject; var Key: Char);
begin
	Case Key Of #22,#27,#28,#29,#92,#96: Key := Chr(0);
	end;
end;

procedure TMBEnh.Btn1CapKeyPress(Sender: TObject; var Key: Char);
begin
	Case Key Of #22,#27,#28,#29,#92,#96: Key := Chr(0);
	end;
end;

procedure TMBEnh.Btn2CapKeyPress(Sender: TObject; var Key: Char);
begin
	Case Key Of #22,#27,#28,#29,#92,#96: Key := Chr(0);
	end;
end;


end.
